home *** CD-ROM | disk | FTP | other *** search
/ Peanuts NeXT Software Archives / Peanuts-1.iso / CDROM / FAQs / Unix / csh-whynot < prev    next >
Encoding:
Internet Message Format  |  1996-10-06  |  16.0 KB

  1. Path: informatik.tu-muenchen.de!fu-berlin.de!nntp.zit.th-darmstadt.de!news.nacamar.de!news.he.net!www.nntp.primenet.com!nntp.primenet.com!feed1.news.erols.com!howland.erols.net!news.mathworks.com!uunet!in1.uu.net!csnews!mox.perl.com!tchrist
  2. From: Tom Christiansen <tchrist@mox.perl.com>
  3. Newsgroups: comp.unix.shell,comp.unix.questions,comp.unix.programmer,comp.answers,news.answers,comp.infosystems.www.authoring.cgi
  4. Subject: Csh Programming Considered Harmful
  5. Followup-To: comp.unix.shell
  6. Date: 6 Oct 1996 14:03:18 GMT
  7. Organization: Perl Training and Consulting
  8. Lines: 558
  9. Approved: news-answers-request@MIT.Edu
  10. Expires: Sun, 1 Dec 1996 12:00:00 GMT
  11. Message-ID: <538e76$8uq$1@csnews.cs.colorado.edu>
  12. NNTP-Posting-Host: perl.com
  13. Originator: tchrist@mox.perl.com
  14. Xref: informatik.tu-muenchen.de comp.unix.shell:43138 comp.unix.questions:101631 comp.unix.programmer:50689 comp.answers:21501 news.answers:83477 comp.infosystems.www.authoring.cgi:45210
  15.  
  16. Archive-name: unix-faq/shell/csh-whynot
  17. Version: $Id: csh-faq,v 1.7 95/09/28 12:52:17 tchrist Exp Locker: tchrist $
  18.  
  19. The following periodic article answers in excruciating detail
  20. the frequently asked question "Why shouldn't I program in csh?".
  21. It is available for anon FTP from perl.com in /pub/perl/versus/csh.whynot.gz
  22.  
  23.            *** CSH PROGRAMMING CONSIDERED HARMFUL ***
  24.  
  25.     Resolved: The csh is a tool utterly inadequate for programming, 
  26.           and its use for such purposes should be strictly banned!
  27.  
  28. I am continually shocked and dismayed to see people write test cases,
  29. install scripts, and other random hackery using the csh.  Lack of
  30. proficiency in the Bourne shell has been known to cause errors in /etc/rc
  31. and .cronrc files, which is a problem, because you *must* write these files
  32. in that language.
  33.  
  34. The csh is seductive because the conditionals are more C-like, so the path
  35. of least resistance is chosen and a csh script is written.  Sadly, this is
  36. a lost cause, and the programmer seldom even realizes it, even when they
  37. find that many simple things they wish to do range from cumbersome to
  38. impossible in the csh.
  39.  
  40.  
  41. 1. FILE DESCRIPTORS
  42.  
  43. The most common problem encountered in csh programming is that
  44. you can't do file-descriptor manipulation.  All you are able to 
  45. do is redirect stdin, or stdout, or dup stderr into stdout. 
  46. Bourne-compatible shells offer you an abundance of more exotic
  47. possibilities.    
  48.  
  49. 1a. Writing Files
  50.  
  51. In the Bourne shell, you can open or dup arbitrary file descriptors.
  52. For example, 
  53.  
  54.     exec 2>errs.out
  55.  
  56. means that from then on, stderr goes into errs file.
  57.  
  58. Or what if you just want to throw away stderr and leave stdout
  59. alone?    Pretty simple operation, eh?
  60.  
  61.     cmd 2>/dev/null
  62.  
  63. Works in the Bourne shell.  In the csh, you can only make a pitiful 
  64. attempt like this:
  65.  
  66.     (cmd > /dev/tty) >& /dev/null
  67.  
  68. But who said that stdout was my tty?  So it's wrong.  This simple
  69. operation *CANNOT BE DONE* in the csh.
  70.  
  71.  
  72. Along these same lines, you can't direct error messages in csh scripts
  73. out stderr as is considered proper.  In the Bourne shell, you might say:
  74.  
  75.     echo "$0: cannot find $file" 1>&2
  76.  
  77. but in the csh, you can't redirect stdout out stderr, so you end
  78. up doing something silly like this:
  79.  
  80.     sh -c 'echo "$0: cannot find $file" 1>&2'
  81.  
  82. 1b. Reading Files
  83.  
  84. In the csh, all you've got is $<, which reads a line from your tty.  What
  85. if you've redirected stdin?  Tough noogies, you still get your tty, which 
  86. you really can't redirect.  Now, the read statement 
  87. in the Bourne shell allows you to read from stdin, which catches
  88. redirection.  It also means that you can do things like this:
  89.  
  90.     exec 3<file1
  91.     exec 4<file2
  92.  
  93. Now you can read from fd 3 and get lines from file1, or from file2 through
  94. fd 4.   In modern, Bourne-like shells, this suffices: 
  95.  
  96.     read some_var 0<&3
  97.     read another_var 0<&4
  98.  
  99. Although in older ones where read only goes from 0, you trick it:
  100.  
  101.     exec 5<&0  # save old stdin
  102.     exec 0<&3; read some_var
  103.     exec 0<&4; read another_var
  104.     exec 0<&5  # restore it
  105.  
  106.  
  107. 1c. Closing FDs
  108.  
  109. In the Bourne shell, you can close file descriptors you don't
  110. want open, like 2>&-, which isn't the same as redirecting it
  111. to /dev/null.
  112.  
  113. 1d. More Elaborate Combinations
  114.  
  115. Maybe you want to pipe stderr to a command and leave stdout alone.
  116. Not too hard an idea, right?  You can't do this in the csh as I
  117. mentioned in 1a.  In a Bourne shell, you can do things like this:
  118.  
  119.     exec 3>&1; grep yyy xxx 2>&1 1>&3 3>&- | sed s/file/foobar/ 1>&2 3>&-
  120.     grep: xxx: No such foobar or directory
  121.  
  122. Normal output would be unaffected.  The closes there were in case
  123. something really cared about all its FDs.  We send stderr to sed,
  124. and then put it back out 2.
  125.  
  126. Consider the pipeline:
  127.  
  128.     A | B | C
  129.  
  130. You want to know the status of C, well, that's easy: it's in $?, or
  131. $status in csh.  But if you want it from A, you're out of luck -- if
  132. you're in the csh, that is.  In the Bourne shell, you can get it, although
  133. doing so is a bit tricky.  Here's something I had to do where I ran dd's
  134. stderr into a grep -v pipe to get rid of the records in/out noise, but had
  135. to return the dd's exit status, not the grep's:
  136.  
  137.     device=/dev/rmt8
  138.     dd_noise='^[0-9]+\+[0-9]+ records (in|out)$'
  139.     exec 3>&1
  140.     status=`((dd if=$device ibs=64k 2>&1 1>&3 3>&- 4>&-; echo $? >&4) |
  141.         egrep -v "$dd_noise" 1>&2 3>&- 4>&-) 4>&1`
  142.     exit $status;
  143.  
  144.  
  145. The csh has also been known to close all open file descriptors besides
  146. the ones it knows about, making it unsuitable for applications that 
  147. intend to inherit open file descriptors.
  148.  
  149.  
  150. 2. COMMAND ORTHOGONALITY
  151.  
  152. 2a. Built-ins
  153.  
  154. The csh is a horrid botch with its built-ins.  You can't put them
  155. together in many reasonable ways.   Even simple little things like this:    
  156.  
  157.         % time | echo
  158.  
  159. which while nonsensical, shouldn't give me this message:
  160.  
  161.         Reset tty pgrp from 9341 to 26678
  162.  
  163. Others are more fun:
  164.  
  165.         % sleep 1 | while
  166.         while: Too few arguments.
  167.         [5] 9402
  168.         % jobs
  169.         [5]     9402 Done                 sleep |
  170.  
  171.  
  172. Some can even hang your shell.  Try typing ^Z while you're sourcing 
  173. something, or redirecting a source command.  Just make sure you have
  174. another window handy.  Or try 
  175.  
  176.     % history | more
  177.  
  178. on some systems.
  179.  
  180. Aliases are not evaluated everywhere you would like them do be:
  181.  
  182.     % alias lu 'ls -u'
  183.     % lu
  184.     HISTORY  News     bin      fortran  lib      lyrics   misc     tex
  185.     Mail     TEX      dehnung  hpview   logs     mbox     netlib
  186.     % repeat 3 lu
  187.     lu: Command not found.
  188.     lu: Command not found.
  189.     lu: Command not found.
  190.  
  191.     % time lu
  192.     lu: Command not found.
  193.  
  194.  
  195. 2b. Flow control
  196.  
  197. You can't mix flow-control and commands, like this:
  198.     
  199.     who | while read line; do
  200.     echo "gotta $line"
  201.     done
  202.  
  203.  
  204. You can't combine multiline constructs in a csh using semicolons.
  205. There's no easy way to do this
  206.  
  207.     alias cmd 'if (foo) then bar; else snark; endif'
  208.  
  209.  
  210. You can't perform redirections with if statements that are
  211. evaluated solely for their exit status:
  212.  
  213.     if ( { grep vt100 /etc/termcap > /dev/null } ) echo ok
  214.  
  215. And even pipes don't work:
  216.  
  217.     if ( { grep vt100 /etc/termcap | sed 's/$/###' } ) echo ok
  218.  
  219. But these work just fine in the Bourne shell:
  220.  
  221.     if grep vt100 /etc/termcap > /dev/null ; then echo ok; fi   
  222.  
  223.     if grep vt100 /etc/termcap | sed 's/$/###/' ; then echo ok; fi
  224.  
  225.  
  226. Consider the following reasonable construct:
  227.  
  228.   if ( { command1 | command2 } ) then
  229.       ...
  230.   endif
  231.  
  232. The output of command1 won't go into the input of command2.  You will get
  233. the output of both commands on standard output.  No error is raised.  In
  234. the Bourne shell or its clones, you would say 
  235.  
  236.     if command1 | command2 ; then
  237.     ...
  238.     fi
  239.  
  240.  
  241. 2c. Stupid parsing bugs
  242.  
  243. Certain reasonable things just don't work, like this:
  244.  
  245.     % kill -1 `cat foo`
  246.     `cat foo`: Ambiguous.
  247.  
  248. But this is ok:
  249.  
  250.     % /bin/kill -1 `cat foo`
  251.  
  252. If you have a stopped job:
  253.  
  254.     [2]     Stopped              rlogin globhost
  255.  
  256. You should be able to kill it with 
  257.  
  258.     % kill %?glob
  259.     kill: No match
  260.  
  261. but
  262.  
  263.     % fg %?glob
  264.  
  265. works.
  266.  
  267. White space can matter:
  268.  
  269.     if(expr)
  270.  
  271. may fail on some versions of csh, while
  272.  
  273.     if (expr)
  274.  
  275. works!  Your vendor may have attempted to fix this bug, but odds are good
  276. that their csh still won't be able to handle
  277.  
  278.     if(0) then
  279.       if(1) then
  280.           echo A: got here
  281.       else
  282.           echo B: got here
  283.       endif
  284.       echo We should never execute this statement
  285.     endif
  286.  
  287.  
  288.  
  289. 3. SIGNALS
  290.  
  291. In the csh, all you can do with signals is trap SIGINT.  In the Bourne
  292. shell, you can trap any signal, or the end-of-program exit.    For example,
  293. to blow away a tempfile on any of a variety of signals:
  294.  
  295.     $ trap 'rm -f /usr/adm/tmp/i$$ ;
  296.         echo "ERROR: abnormal exit";
  297.         exit' 1 2 3 15
  298.  
  299.     $ trap 'rm tmp.$$' 0   # on program exit
  300.  
  301.  
  302.  
  303. 4. QUOTING
  304.  
  305. You can't quote things reasonably in the csh:
  306.  
  307.     set foo = "Bill asked, \"How's tricks?\""
  308.  
  309. doesn't work.  This makes it really hard to construct strings with
  310. mixed quotes in them.  In the Bourne shell, this works just fine. 
  311. In fact, so does this:
  312.  
  313.      cd /mnt; /usr/ucb/finger -m -s `ls \`u\``
  314.  
  315. Dollar signs cannot be escaped in double quotes in the csh.  Ug.
  316.  
  317.     set foo = "this is a \$dollar quoted and this is $HOME not quoted" 
  318.     dollar: Undefined variable.
  319.  
  320. You have to use backslashes for newlines, and it's just darn hard to
  321. get them into strings sometimes.
  322.  
  323.     set foo = "this \
  324.     and that";
  325.     echo $foo
  326.     this  and that
  327.     echo "$foo"
  328.     Unmatched ".  
  329.  
  330. Say what?  You don't have these problems in the Bourne shell, where it's
  331. just fine to write things like this:
  332.  
  333.     echo     'This is 
  334.          some text that contains
  335.          several newlines.'
  336.  
  337.  
  338. As distributed, quoting history references is a challenge.  Consider:
  339.  
  340.     % mail adec23!alberta!pixel.Convex.COM!tchrist
  341.     alberta!pixel.Convex.COM!tchri: Event not found.
  342.  
  343.  
  344. 5. VARIABLE SYNTAX
  345.  
  346. There's this big difference between global (environment) and local
  347. (shell) variables.  In csh, you use a totally different syntax 
  348. to set one from the other.  
  349.  
  350. In the Bourne shell, this 
  351.     VAR=foo cmds args
  352.  is the same as
  353.     (export VAR; VAR=foo; cmd args)
  354. or csh's
  355.     (setenv VAR;  cmd args)
  356.  
  357. You can't use :t, :h, etc on envariables.  Watch:
  358.     echo Try testing with $SHELL:t
  359.  
  360. It's really nice to be able to say
  361.     
  362.     ${PAGER-more}
  363. or
  364.     FOO=${BAR:-${BAZ}}
  365.  
  366. to be able to run the user's PAGER if set, and more otherwise.
  367. You can't do this in the csh.  It takes more verbiage.
  368.  
  369. You can't get the process number of the last background command from the
  370. csh, something you might like to do if you're starting up several jobs in
  371. the background.  In the Bourne shell, the pid of the last command put in
  372. the background is available in $!.
  373.  
  374. The csh is also flaky about what it does when it imports an 
  375. environment variable into a local shell variable, as it does
  376. with HOME, USER, PATH, and TERM.  Consider this:
  377.  
  378.     % setenv TERM '`/bin/ls -l / > /dev/tty`'
  379.     % csh -f
  380.  
  381. And watch the fun!
  382.  
  383.  
  384. 6. EXPRESSION EVALUATION
  385.  
  386. Consider this statement in the csh:
  387.  
  388.  
  389.     if ($?MANPAGER) setenv PAGER $MANPAGER
  390.  
  391.  
  392. Despite your attempts to only set PAGER when you want
  393. to, the csh aborts:
  394.  
  395.     MANPAGER: Undefined variable.
  396.  
  397. That's because it parses the whole line anyway AND EVALUATES IT!
  398. You have to write this:
  399.  
  400.     if ($?MANPAGER) then
  401.     setenv PAGER $MANPAGER
  402.     endif
  403.  
  404. That's the same problem you have here:
  405.  
  406.     if ($?X && $X == 'foo') echo ok
  407.     X: Undefined variable
  408.  
  409. This forces you to write a couple nested if statements.  This is highly
  410. undesirable because it renders short-circuit booleans useless in
  411. situations like these.  If the csh were the really C-like, you would
  412. expect to be able to safely employ this kind of logic.  Consider the
  413. common C construct:
  414.  
  415.     if (p && p->member) 
  416.  
  417. Undefined variables are not fatal errors in the Bourne shell, so 
  418. this issue does not arise there.
  419.  
  420. While the csh does have built-in expression handling, it's not
  421. what you might think.  In fact, it's space sensitive.  This is an
  422. error
  423.  
  424.    @ a = 4/2
  425.  
  426. but this is ok
  427.  
  428.    @ a = 4 / 2
  429.  
  430.  
  431. The ad hoc parsing csh employs fouls you up in other places 
  432. as well.  Consider:
  433.  
  434.     % alias foo 'echo hi' ; foo
  435.     foo: Command not found.
  436.     % foo
  437.     hi
  438.  
  439.  
  440.  
  441. 7. ERROR HANDLING
  442.  
  443. Wouldn't it be nice to know you had an error in your script before
  444. you ran it?   That's what the -n flag is for: just check the syntax.
  445. This is especially good to make sure seldom taken segments of code
  446. code are correct.  Alas, the csh implementation of this doesn't work.
  447. Consider this statement:
  448.  
  449.     exit (i)
  450.  
  451. Of course, they really meant
  452.  
  453.     exit (1)
  454.  
  455. or just
  456.  
  457.     exit 1
  458.  
  459. Either shell will complain about this.  But if you hide this in an if
  460. clause, like so:
  461.  
  462.     #!/bin/csh -fn
  463.     if (1) then
  464.     exit (i)
  465.     endif
  466.  
  467. The csh tells you there's nothing wrong with this script.  The equivalent
  468. construct in the Bourne shell, on the other hand, tells you this:
  469.  
  470.  
  471.     #!/bin/sh -n
  472.     if (1) then
  473.     exit (i)
  474.     endif
  475.  
  476.     /tmp/x: syntax error at line 3: `(' unexpected
  477.  
  478.  
  479.  
  480. RANDOM BUGS
  481.  
  482. Here's one:
  483.  
  484.     fg %?string
  485.     ^Z
  486.     kill  %?string
  487.     No match.
  488.  
  489. Huh? Here's another
  490.  
  491.     !%s%x%s
  492.  
  493. Coredump, or garbage.
  494.  
  495. If you have an alias with backquotes, and use that in backquotes in 
  496. another one, you get a coredump.
  497.  
  498. Try this:
  499.     % repeat 3 echo "/vmu*"
  500.     /vmu*
  501.     /vmunix
  502.     /vmunix
  503. What???
  504.  
  505.  
  506. Here's another one:
  507.  
  508.     % mkdir tst
  509.     % cd tst
  510.     % touch '[foo]bar'
  511.     % foreach var ( * )
  512.     > echo "File named $var"
  513.     > end
  514.     foreach: No match.
  515.  
  516.  
  517. 8. SUMMARY
  518.  
  519.  
  520. While some vendors have fixed some of the csh's bugs (the tcsh also does
  521. much better here), many have added new ones.  Most of its problems can
  522. never be solved because they're not actually bugs per se, but rather the
  523. direct consequences of braindead design decisions.  It's inherently flawed.
  524.  
  525. Do yourself a favor, and if you *have* to write a shell script, do it in the 
  526. Bourne shell.  It's on every UNIX system out there.  However, behavior 
  527. can vary.
  528.  
  529. There are other possibilities.
  530.  
  531. The Korn shell is the preferred programming shell by many sh addicts,
  532. but it still suffers from inherent problems in the Bourne shell's design,
  533. such as parsing and evaluation horrors.  The Korn shell or its
  534. public-domain clones and supersets (like bash) aren't quite so ubiquitous
  535. as sh, so it probably wouldn't be wise to write a sharchive in them that
  536. you post to the net.  When 1003.2 becomes a real standard that companies
  537. are forced to adhere to, then we'll be in much better shape.  Until
  538. then, we'll be stuck with bug-incompatible versions of the sh lying about.
  539.  
  540. The Plan 9 shell, rc, is much cleaner in its parsing and evaluation; it is
  541. not widely available, so you'd be significantly sacrificing portability.
  542. No vendor is shipping it yet.
  543.  
  544. If you don't have to use a shell, but just want an interpreted language,
  545. many other free possibilities present themselves, like Perl, REXX, TCL,
  546. Scheme, or Python.  Of these, Perl is probably the most widely available
  547. on UNIX (and many other) systems and certainly comes with the most
  548. extensive UNIX interface.  Increasing numbers vendors ship Perl with 
  549. their standard systems.  (See the comp.lang.perl FAQ for a list.)
  550.  
  551. If you have a problem that would ordinarily use sed or awk or sh, but it
  552. exceeds their capabilities or must run a little faster, and you don't want
  553. to write the silly thing in C, then Perl may be for you.  You can get
  554. at networking functions, binary data, and most of the C library. There
  555. are also translators to turn your sed and awk scripts into Perl scripts,
  556. as well as a symbolic debugger.  Tchrist's personal rule of thumb is
  557. that if it's the size that fits in a Makefile, it gets written in the
  558. Bourne shell, but anything bigger gets written in Perl.
  559.  
  560. See the comp.lang.{perl,rexx,tcl} newsgroups for details about these
  561. languages (including FAQs), or David Muir Sharnoff's comparison of 
  562. freely available languages and tools in comp.lang.misc and news.answers.
  563.  
  564. NOTE: Doug Hamilton <hamilton@bix.com> has a program that he sells for
  565. profit for little toy non-UNIX systems.  He calls it 'csh' or the 
  566. 'hamilton csh', but it's not a csh as it's neither bug nor feature
  567. compatible with the real csh.  Actually, he's fixed a great deal, but
  568. in doing so, has created a totally different shell.
  569. -- 
  570. Tom Christiansen      Perl Consultant, Gamer, Hiker      tchrist@mox.perl.com
  571. "Espousing the eponymous /cgi-bin/perl.exe?FMH.pl execution model is like 
  572. reading a suicide note -- three days too late."
  573.         --Tom Christiansen <tchrist@mox.perl.com>
  574.